unit f_propsave;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, PropSaveMain, PropSaveOtherComps, ImgList, ComCtrls, ToolWin,
  rHTMLLabel, rImprovedComps, ExtCtrls;

type
  TPropSaveForm = class(TForm)
    PS: TPropSaveMain;
    FontDlg: TFontDialog;
    PSFile: TPropSaveFile;
    RosiCompsPropSave1: TRosiCompsPropSave;
    GroupBox1: TGroupBox;
    Panel3: TPanel;
    Label4: TLabel;
    ListBox: TListBox;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    cbDropDownList: TComboBox;
    cbDropDown: TComboBox;
    Edit: TEdit;
    CheckBox: TCheckBox;
    RadioGroup: TRadioGroup;
    TabControl1: TTabControl;
    ColorBox1: TColorBox;
    Label6: TLabel;
    rHTMLLabel1: TrHTMLLabel;
    rGroupBox1: TrGroupBox;
    FormatLabel1: TrHTMLLabel;
    rGroupBox2: TrGroupBox;
    btOpenChild: TrButton;
    btSetFont: TrButton;
    btSetDefault: TrButton;
    lblTest: TLabel;
    btShowIni: TButton;
    rMemoEx: TrMemoEx;
    procedure PSReadProperties(PSFile: TPropSaveFile; Key: String);
    procedure PSSaveProperties(PSFile: TPropSaveFile; Key: String);
    procedure btOpenChildClick(Sender: TObject);
    procedure btSetFontClick(Sender: TObject);
    procedure btSetDefaultClick(Sender: TObject);
    procedure btShowIniClick(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
  end;

var
  PropSaveForm: TPropSaveForm;

implementation

{$R *.DFM}
uses rtool, f_propsavechild;

procedure TPropSaveForm.btOpenChildClick(Sender: TObject);
begin
  Application.CreateForm(TPropSaveChildForm, PropSaveChildForm);
  PropSaveChildForm.ShowModal;
  PropSaveChildForm.Free;
end;

procedure TPropSaveForm.btSetDefaultClick(Sender: TObject);
begin
  PS.PropSaveFile.Clear;
  PS.PropSaveFile.SaveFile('');
  PS.PropSaveFile.DisableAll:=true;
  ShowMessage('Close the application and run again with default values.');
end;

procedure TPropSaveForm.btSetFontClick(Sender: TObject);
begin
  FontDlg.Font:=lblTest.Font;
  if FontDlg.Execute then
    lblTest.Font:=FontDlg.Font;
end;

procedure TPropSaveForm.btShowIniClick(Sender: TObject);
begin
  PS.SaveProperties;
  PSFile.SaveFile('');
  RunFile(PSFile.GetFileName, '', '', SW_SHOW);
end;

procedure TPropSaveForm.PSReadProperties(PSFile: TPropSaveFile; Key: String);
begin
  PSFile.ReadFont(Key + '.' + lblTest.Name, lblTest.Font);
end;

procedure TPropSaveForm.PSSaveProperties(PSFile: TPropSaveFile; Key: String);
begin
  PSFile.WriteFont(Key + '.' + lblTest.Name, lblTest.Font);
end;

end.
