unit dm_data;

interface

uses
  SysUtils, Classes, Dialogs, Controls, DB, ADODB, rDBGrid, rDBGridSorter_ADO;

type
  TDMData = class(TDataModule)
    DBCon: TADOConnection;
    rDBGridSorter: TrDBGridSorter_ADO;
    qEmp: TADOQuery;
    qEmpEmployeeID: TAutoIncField;
    qEmpLastName: TWideStringField;
    qEmpFirstName: TWideStringField;
    qEmpTitle: TWideStringField;
    qEmpTitleOfCourtesy: TWideStringField;
    qEmpBirthDate: TDateTimeField;
    qEmpHireDate: TDateTimeField;
    qEmpPartTime: TBooleanField;
    qEmpSalary: TFloatField;
    qEmpAddress: TWideStringField;
    qEmpCity: TWideStringField;
    qEmpRegion: TWideStringField;
    qEmpPostalCode: TWideStringField;
    qEmpCountry: TWideStringField;
    qEmpHomePhone: TWideStringField;
    qEmpExtension: TWideStringField;
    qEmpPhoto: TBlobField;
    qEmpNotes: TWideMemoField;
    qEmpReportsTo: TIntegerField;
    dsEmp: TDataSource;
    qLookupProducts: TADOQuery;
    qLookupProductsProductID: TAutoIncField;
    qLookupProductsProductName: TWideStringField;
    qLookupProductsSupplierID: TIntegerField;
    qLookupProductsSupplier: TWideStringField;
    qLookupProductsCategoryID: TIntegerField;
    qLookupProductsCategory: TWideStringField;
    qLookupProductsQuantityPerUnit: TWideStringField;
    qLookupProductsUnitPrice: TBCDField;
    qLookupProductsUnitsInStock: TSmallintField;
    qLookupProductsStockLevel: TWideStringField;
    qLookupProductsUnitsOnOrder: TSmallintField;
    qLookupProductsReorderLevel: TSmallintField;
    qLookupProductsDiscontinued: TBooleanField;
    qLookupProductsProductColor: TWideStringField;
    dsLookupProducts: TDataSource;
    aqSuppliers: TADOQuery;
    aqSuppliersSupplierID: TAutoIncField;
    aqSuppliersCompanyName: TWideStringField;
    aqSuppliersContactName: TWideStringField;
    aqSuppliersCity: TWideStringField;
    aqCategories: TADOQuery;
    aqCategoriesCategoryID: TAutoIncField;
    aqCategoriesCategoryName: TWideStringField;
    qCust: TADOQuery;
    qCustCustomerID: TWideStringField;
    qCustCompanyName: TWideStringField;
    qCustContactName: TWideStringField;
    qCustContactTitle: TWideStringField;
    qCustAddress: TWideStringField;
    qCustCity: TWideStringField;
    qCustRegion: TWideStringField;
    qCustPostalCode: TWideStringField;
    qCustCountry: TWideStringField;
    qCustPhone: TWideStringField;
    qCustFax: TWideStringField;
    qCustEmail: TWideStringField;
    qCustWWW: TWideStringField;
    qCustActive: TWideStringField;
    dsCust: TDataSource;
    qProducts: TADOQuery;
    qProductsProductID: TAutoIncField;
    qProductsProductName: TWideStringField;
    qProductsSupplierID: TIntegerField;
    qProductsCategoryID: TIntegerField;
    qProductsQuantityPerUnit: TWideStringField;
    qProductsUnitPrice: TBCDField;
    qProductsUnitsInStock: TSmallintField;
    qProductsUnitsOnOrder: TSmallintField;
    qProductsReorderLevel: TSmallintField;
    qProductsDiscontinued: TBooleanField;
    qProductsStockLevel: TWideStringField;
    qProductsFlag: TIntegerField;
    dsProducts: TDataSource;
    qEmpAdr: TADOQuery;
    qEmpAdrAddr: TWideStringField;
    qEmpSum1: TADOQuery;
    qEmpSum1EmployeeID: TWideStringField;
    qEmpSum1LastName: TIntegerField;
    qEmpSum1Salary: TFloatField;
    qEmpSum2: TADOQuery;
    qEmpSum2EmployeeID: TWideStringField;
    qEmpSum2LastName: TIntegerField;
    qEmpSum2Salary: TFloatField;
    qEmpSum3: TADOQuery;
    qEmpSum3SumOfLastName: TIntegerField;
    qEmpSum3SumOfSalary: TFloatField;
    qEmpSum3SumOfPartTime: TFloatField;
    qEmpSum3SumOfCountry: TFloatField;
    qEmpSum3SumOfPhoto: TFloatField;
    dsEmpSum3: TDataSource;
    dsEmpSum2: TDataSource;
    dsEmpSum1: TDataSource;
    qCategories: TADOQuery;
    qCategoriesCategoryID: TAutoIncField;
    qCategoriesCategoryName: TWideStringField;
    dsCategories: TDataSource;
    qProdCatMatch: TADOQuery;
    qProdCatMatchProductID: TIntegerField;
    qProdCatMatchCategoryID: TIntegerField;
    dsProdCatMatch: TDataSource;
    qEmpList: TADOQuery;
    qEmpListEmployeeID: TAutoIncField;
    qEmpListFullName: TWideStringField;
    dsEmpList: TDataSource;
    qTitleList: TADOQuery;
    qTitleListTitle: TWideStringField;
    qTitleCList: TADOQuery;
    qTitleCListTitleOfCourtesy: TWideStringField;
    qValDef: TADOQuery;
    qValDefValueID: TIntegerField;
    qValDefValueName: TWideStringField;
    qValDefValueUnit: TWideStringField;
    dsValDef: TDataSource;
    qMatValues: TADOQuery;
    qMatValuesID: TAutoIncField;
    qMatValuesMaterialID: TIntegerField;
    qMatValuesValueID: TIntegerField;
    qMatValuesNote: TWideStringField;
    qTemperatures: TADOQuery;
    qTemperaturesTemperature: TIntegerField;
    qTempValues: TADOQuery;
    qTempValuesID: TAutoIncField;
    qTempValuesMaterialID: TIntegerField;
    qTempValuesValueID: TIntegerField;
    qTempValuesTemperature: TIntegerField;
    qOrders: TADOTable;
    qOrdersOrderID: TIntegerField;
    qOrdersCustomerID: TWideStringField;
    qOrdersEmployeeID: TIntegerField;
    qOrdersOrderDate: TDateTimeField;
    qOrdersRequiredDate: TDateTimeField;
    qOrdersShippedDate: TDateTimeField;
    qOrdersShipVia: TIntegerField;
    qOrdersFreight: TBCDField;
    qOrdersShipName: TWideStringField;
    qOrdersShipAddress: TWideStringField;
    qOrdersShipCity: TWideStringField;
    qOrdersShipRegion: TWideStringField;
    qOrdersShipPostalCode: TWideStringField;
    qOrdersShipCountry: TWideStringField;
    dsOrders: TDataSource;
    qOrderDetails: TADOTable;
    qOrderDetailsOrderDetailID: TAutoIncField;
    qOrderDetailsOrderID: TIntegerField;
    qOrderDetailsProductID: TIntegerField;
    qOrderDetailsProductName: TWideStringField;
    qOrderDetailsUnitPrice: TBCDField;
    qOrderDetailsQuantity: TSmallintField;
    qOrderDetailsDiscount: TFloatField;
    qOrderDetailsPrice: TFloatField;
    dsOrderDetails: TDataSource;
    qMatValuesNumValue: TFloatField;
    qTempValuesNumValue: TFloatField;
    qEmpListTitle: TWideStringField;
    qEmpReportsToName: TWideStringField;
    qTreeData: TADOQuery;
    dsTreeData: TDataSource;
    qTreeDataID: TAutoIncField;
    qTreeDataParentID: TIntegerField;
    qTreeDataNodeCode: TWideStringField;
    qTreeDataNodeName: TWideStringField;
    qTreeDataSomeText1: TWideStringField;
    qTreeDataSomeNumber1: TIntegerField;
    qTreeDataSomeDate1: TDateTimeField;
    qEmpNotesRTF: TWideMemoField;
    procedure qEmpAfterPost(DataSet: TDataSet);
    procedure qEmpAfterDelete(DataSet: TDataSet);
    procedure qEmpBeforeDelete(DataSet: TDataSet);
    procedure qEmpSalaryValidate(Sender: TField);
  private
  public
    AfterUpdate: TDataSetNotifyEvent;
    function DBConnect: string;
    procedure DBDisConnect;
    procedure ExecSQL(cmd: string);
    procedure SetQuery(DataSet: TDataSet; SQL: string);
    procedure SetQueryParam(DataSet: TDataSet; ParamName, ParamStr: string);
    procedure DoAfterUpdate(DataSet: TDataSet);
  end;

var
  DMData: TDMData;

implementation

{$R *.dfm}
uses rstring, rdlg, rtool, rdbtool;

const
  DefaultDB = 'data\Demo.mdb';
  ConStr = 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=';
  // ConStr = 'Provider=Microsoft.ACE.OLEDB.12.0;Data Source=';

function TDMData.DBConnect: string;
begin
  Result:='';
  DBDisConnect;
  DBCon.ConnectionString:=ConStr + GetAppDir + DefaultDB;
  try
    DBCon.Open;
    Result:=GetAppDir + DefaultDB;
  except
    on E: exception do
      ShowErr(sError, E, true);
  end;
end;

procedure TDMData.DBDisConnect;
begin
  DBCon.Close;
end;

procedure TDMData.SetQuery(DataSet: TDataSet; SQL: string);
begin
  DataSet.Close;
  (DataSet as TADOQuery).SQL.Text:=SQL;
end;

procedure TDMData.SetQueryParam(DataSet: TDataSet; ParamName: string; ParamStr: string);
begin
  DataSet.Close;
  (DataSet as TADOQuery).Parameters.ParamByName(ParamName).Value:=ParamStr;
end;

procedure TDMData.DoAfterUpdate(DataSet: TDataSet);
begin
  if Assigned(AfterUpdate) then
    AfterUpdate(DataSet);
end;

procedure TDMData.ExecSQL(cmd: string);
begin
  DBCon.Execute(cmd);
end;

procedure TDMData.qEmpAfterPost(DataSet: TDataSet);
begin
  DoAfterUpdate(DataSet);
end;

procedure TDMData.qEmpBeforeDelete(DataSet: TDataSet);
begin
  if DlgQ(rstring.sDeleteQ) <> mrYes then
    Abort;
end;

procedure TDMData.qEmpSalaryValidate(Sender: TField);
begin
  if Sender.AsFloat<0 then
  begin
    DlgE('Salary cannot be negative.');
    Abort;
  end;
end;

procedure TDMData.qEmpAfterDelete(DataSet: TDataSet);
begin
  DoAfterUpdate(DataSet);
end;

end.
