unit f_rdbcomp_dbblob;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, rDBComponents, StdCtrls, rImprovedComps, Grids, DBGrids,
  rDBGrid, DB, ADODB, ComCtrls;

type
  TrDBComp_DBBlob = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    qDocList: TADOQuery;
    qDocListDocumentID: TAutoIncField;
    qDocListDocumentName: TWideStringField;
    qDocListFileName: TWideStringField;
    qDocListNote: TWideMemoField;
    dsDocList: TDataSource;
    qDocContent: TADOQuery;
    qDocContentDocumentID: TAutoIncField;
    qDocContentFileContent: TBlobField;
    dsDocContent: TDataSource;
    rDBGrid1: TrDBGrid;
    rGroupBox3: TrGroupBox;
    btAdd: TrDBMoveButton;
    btPost: TrDBMoveButton;
    btCancel: TrDBMoveButton;
    rDBBlob1: TrDBBlob;
    procedure FormShow(Sender: TObject);
    procedure qDocListBeforePost(DataSet: TDataSet);
    procedure rDBBlob1PrepareBlobDataset(Sender: TObject);
    procedure btAddClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  rDBComp_DBBlob: TrDBComp_DBBlob;

implementation

{$R *.dfm}

uses dm_data, f_main, rstring, rdlg, rtool, rdbtool;

procedure TrDBComp_DBBlob.FormShow(Sender: TObject);
begin
  // open empty list of content (only to activate Blob functions)
  // specified content is loaded later only if needed by event PrepareBlobDataset
  qDocContent.Close;
  qDocContent.SQL[1]:='WHERE 1=0';
  qDocContent.Open;

  // open list of doc without content to keep it fast - sql has to specify exact list of fields
  qDocList.Close;
  qDocList.Open;
end;

procedure TrDBComp_DBBlob.qDocListBeforePost(DataSet: TDataSet);
begin
  if IsEditing(qDocContent) then
    qDocContent.Post;
end;

procedure TrDBComp_DBBlob.rDBBlob1PrepareBlobDataset(Sender: TObject);
begin
  // open content for active record
  qDocContent.Close;
  qDocContent.SQL[1]:=Format('WHERE DocumentID=%d',[qDocListDocumentID.AsInteger]);
  qDocContent.Open;
end;

procedure TrDBComp_DBBlob.btAddClick(Sender: TObject);
begin
  // add new empty record and post immediately to allow loading of the file content
  self.qDocList.Append;
  self.qDocListDocumentName.AsString:='(noname)';
  self.qDocList.Post;
end;

end.
