unit f_rdbtreeview;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, rDBTreeView, DB, PropSaveMain,
  PropSaveGrids, Grids, DBGrids, rDBGrid, printers, ExtCtrls, rHTMLLabel,
  rImprovedComps;

type
  TrDBTreeViewTest = class(TForm)
    PropSaveMain1: TPropSaveMain;
    rDBGridsPropSave1: TrDBGridsPropSave;
    pc: TPageControl;
    TabSheet3: TTabSheet;
    grOrder: TrDBGrid;
    grCustList: TrDBGrid;
    grItems: TrDBGrid;
    pc2: TPageControl;
    ts1: TTabSheet;
    rDBTreeViewAllRec: TrDBTreeView;
    lblInfo1: TrHTMLLabel;
    ts2: TTabSheet;
    Panel1: TPanel;
    btPrint: TButton;
    btPrintDirect: TButton;
    Panel2: TPanel;
    lblInfo: TrHTMLLabel;
    btSave: TButton;
    btCancel: TButton;
    lblInfo2: TrHTMLLabel;
    rDBTreeViewOneRec: TrDBTreeView;
    lblInfo3: TrHTMLLabel;
    tc3: TTabSheet;
    rDBTreeViewML: TrDBTreeView;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btPrintClick(Sender: TObject);
    procedure btPrintDirectClick(Sender: TObject);
    procedure rDBTreeViewAllRecChange(Sender: TObject; Node: TTreeNode);
    procedure rDBTreeView3Edited(Sender: TObject; Node: TTreeNode; var S: string);
    procedure rDBTreeViewAllRecItemMoved(Sender: TObject; Node: TTreeNode);
    procedure btSaveClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure pc2Change(Sender: TObject);
    procedure grOrderDblClick(Sender: TObject);
    procedure rDBTreeViewMLCustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
  private
    procedure ProcOneItem(Sender: TObject; Node: TTreeNode);
  public
    procedure ShowNodeData(aNode: TTreeNode; ActStr: string);
  end;

var
  rDBTreeViewTest: TrDBTreeViewTest;

implementation

uses dm_data, f_main, rtool, rdbtool, rDBPrint, rDBPrintDirect, rDBFind;
{$R *.dfm}

procedure TrDBTreeViewTest.FormShow(Sender: TObject);
begin
  // demo contain 2 TreeViews - set masterdataset only for active TreeView
  pc2.ActivePageIndex:=0;
  pc2Change(nil);
  WCursor;
  try
    // dataset open and close order is important !
    DMData.qOrderDetails.Close;
    DMData.qOrders.Close;
    DMData.qCust.Close;
    DMData.qOrderDetails.Open;
    DMData.qOrders.Open;
    DMData.qCust.Open;
    // load manually all rec.
    rDBTreeViewAllRec.RefreshData;
  finally
    NCursor;
  end;
end;

procedure TrDBTreeViewTest.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DMData.qOrderDetails.Close;
  DMData.qOrders.Close;
  DMData.qCust.Close;
end;

procedure TrDBTreeViewTest.pc2Change(Sender: TObject);
begin
  case pc2.ActivePageIndex of
    0:
      self.rDBTreeViewOneRec.MasterDataSource:=nil;
    1:
      self.rDBTreeViewOneRec.MasterDataSource:=DMData.dsCust;
    2:
      begin
        DMData.qTreeData.Close;
        DMData.qTreeData.Open;
        rDBTreeViewML.RefreshData();
      end;
  end;
end;

procedure TrDBTreeViewTest.grOrderDblClick(Sender: TObject);
var
  tn: TTreeNode;
begin
  if pc2.ActivePageIndex = 1 then
  begin
    // select node according active record
    tn:=rDBTreeViewOneRec.FindNode(DMData.qOrdersOrderID, DMData.qOrdersOrderID.AsVariant);
    if Assigned(tn) then
      self.rDBTreeViewOneRec.Selected:=tn;
  end;
end;

procedure TrDBTreeViewTest.ShowNodeData(aNode: TTreeNode; ActStr: string);
var
  no: TNodeObject;
begin
  lblInfo.CaptionStrings.Clear;
  if Assigned(aNode) and Assigned(aNode.Data) then
  begin
    no:=aNode.Data;
    lblInfo.CaptionStrings.Add(Format('Action: <B>%s</B>', [ActStr]));
    if no.IsTitle then
      lblInfo.CaptionStrings.Add('TITLE item');
    if no.IsEmptyDataset then
      lblInfo.CaptionStrings.Add('EMPTY DATASET item');
    lblInfo.CaptionStrings.Add('RecNo: ' + IntToStr(no.RecNo));
    if Assigned(no.KeyField) then
    begin
      lblInfo.CaptionStrings.Add('KeyField: ' + no.KeyField.DataSet.Name + '.' + no.KeyField.FieldName);
      lblInfo.CaptionStrings.Add('KeyField Value: ' + VarToStr(no.KeyValue));
    end;
  end
  else
    lblInfo.CaptionStrings.Add('no data');
end;

procedure TrDBTreeViewTest.rDBTreeViewAllRecChange(Sender: TObject; Node: TTreeNode);
begin
  ShowNodeData(Node, 'Select');
end;

procedure TrDBTreeViewTest.rDBTreeViewMLCustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
// var r: TRect;
begin
  if Node.Level = 0 then
    Sender.Canvas.Font.Style:=[fsBold];
  // r:=Node.DisplayRect(true);
  // Sender.Canvas.TextRect(r,r.Left,r.Top,'test');
  // DefaultDraw:=false;
end;

procedure TrDBTreeViewTest.rDBTreeView3Edited(Sender: TObject; Node: TTreeNode; var S: string);
begin
  ShowNodeData(Node, 'Value changed to: ' + S);
end;

procedure TrDBTreeViewTest.rDBTreeViewAllRecItemMoved(Sender: TObject; Node: TTreeNode);
begin
  ShowNodeData(Node, 'Selected item moved to following item');
end;

procedure TrDBTreeViewTest.ProcOneItem(Sender: TObject; Node: TTreeNode);
var
  tnobj, parentobj: TNodeObject;
  cmd: string;
begin
  tnobj:=Node.Data;
  if tnobj.ItemChanged and (tnobj.KeyField = DMData.qCustCustomerID) then
  begin
    // update customer name directly in dataset
    if LocateRecord(tnobj.KeyField, tnobj.KeyValue) then
    begin
      DMData.qCust.Edit;
      DMData.qCustCompanyName.AsString:=Node.Text;
      DMData.qCust.Post;
    end;
  end;
  if tnobj.ItemMoved and (tnobj.KeyField = DMData.qOrdersOrderID) then
  begin
    // relink order to another CustomerID
    parentobj:=Node.Parent.Data;
    // direct update is not possible for master-detail dataset, record is not accessible
    // use SQL or another independent dataset
    cmd:='UPDATE Orders SET CustomerID=''%s'' WHERE OrderID=%d';
    cmd:=Format(cmd, [VarToStr(parentobj.KeyValue), Integer(tnobj.KeyValue)]);
    DMData.ExecSQL(cmd);
  end;
  if tnobj.ItemMoved and (tnobj.KeyField = DMData.qOrderDetailsOrderDetailID) then
  begin
    // relink OrderDetail to another OrderID
    parentobj:=Node.Parent.Data;
    // direct update is not possible for master-detail dataset, record is not accessible
    // use SQL or another independent dataset
    cmd:='UPDATE [Order Details] SET OrderID=%d WHERE OrderDetailID=%d';
    cmd:=Format(cmd, [Integer(parentobj.KeyValue), Integer(tnobj.KeyValue)]);
    DMData.ExecSQL(cmd);
  end;
end;

procedure TrDBTreeViewTest.btCancelClick(Sender: TObject);
begin
  rDBTreeViewAllRec.RefreshData(false, true);
end;

procedure TrDBTreeViewTest.btSaveClick(Sender: TObject);
begin
  rDBTreeViewAllRec.ProcessAllItems(true, true, ProcOneItem, true);
  DMData.qOrders.Close;
  DMData.qOrderDetails.Close;
  DMData.qOrders.Open;
  DMData.qOrderDetails.Open;
end;

procedure TrDBTreeViewTest.btPrintClick(Sender: TObject);
begin
  rDBPrint.DBPrint(rDBTreeViewOneRec, 'Title');
end;

procedure TrDBTreeViewTest.btPrintDirectClick(Sender: TObject);
begin
  rDBPrintDirect.DBPrintDirect(rDBTreeViewOneRec, 'Title');
end;

end.
