unit f_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ImgList, ComCtrls, Buttons, ExtCtrls, rHTMLLabel,
  rImprovedComps, rMapiMail;

type
  TMain = class(TForm)
    rHTMLLabel1: TrHTMLLabel;
    Label1: TLabel;
    rHTMLLabel2: TrHTMLLabel;
    rMapiEmail1: TrMapiEmail;
    eSendTo: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    eCopyTo: TEdit;
    Label4: TLabel;
    eBlindTo: TEdit;
    Label5: TLabel;
    eSubject: TEdit;
    Label6: TLabel;
    mBody: TMemo;
    Label7: TLabel;
    gbFiles: TrGroupBox;
    lbFiles: TListBox;
    btGenInt: TButton;
    lbClear: TrURLLabel;
    Label8: TLabel;
    eResult: TEdit;
    btAddBatch: TButton;
    btSendBatch: TButton;
    btGetExt: TButton;
    btGenAuto: TButton;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    chSendAuto: TCheckBox;
    rbMapi: TRadioButton;
    rbOutlook: TRadioButton;
    procedure btGenIntClick(Sender: TObject);
    procedure gbFilesDropFiles(Sender: TObject; X, Y: Integer);
    procedure lbClearClick(Sender: TObject);
    procedure btAddBatchClick(Sender: TObject);
    procedure btSendBatchClick(Sender: TObject);
    procedure btGetExtClick(Sender: TObject);
    procedure btGenAutoClick(Sender: TObject);
  private
    procedure SeparateEmails(Emails, Separator: string; List: TStrings);
    procedure FillEmail;
    procedure SendMail(MType: TRunMailType);
  public
  end;

var
  Main: TMain;

implementation

{$R *.dfm}
uses RosiCompGlobalCfg, rdlg, rtool, rstring, rtip;

procedure TMain.gbFilesDropFiles(Sender: TObject; X, Y: Integer);
var
  i: Integer;
begin
  for i:=0 to gbFiles.DropFilesCount - 1 do
    lbFiles.Items.Add(gbFiles.DropFileNames[i]);
end;

procedure TMain.lbClearClick(Sender: TObject);
begin
  lbFiles.Clear;
end;

procedure TMain.SeparateEmails(Emails, Separator: string; List: TStrings);
var
  p: Integer;
  em: string;
begin
  List.Clear;
  repeat
    p:=Pos(Separator, Emails);
    if p > 0 then
    begin
      em:=copy(Emails, 1, p - 1);
      Emails:=copy(Emails, p + 1, Length(Emails));
    end
    else
      em:=Emails;
    em:=Trim(em);
    if em <> '' then
      List.Add(em);
  until p = 0;
end;

procedure TMain.FillEmail;
begin
  SeparateEmails(eSendTo.Text, ';', rMapiEmail1.SendTo);
  SeparateEmails(eCopyTo.Text, ';', rMapiEmail1.CopyTo);
  SeparateEmails(eBlindTo.Text, ';', rMapiEmail1.BlindCopyTo);
  rMapiEmail1.Subject:=eSubject.Text;
  rMapiEmail1.Body.Assign(mBody.Lines);
  rMapiEmail1.Attachments.Assign(lbFiles.Items);
end;

procedure TMain.SendMail(MType: TRunMailType);
var res: boolean;
begin
  FillEmail;
  rMapiEmail1.SendAutomatically:=chSendAuto.Checked;
  if rbMapi.Checked then
    res:=rMapiEmail1.SendMapiMail(MType)
  else
    res:=rMapiEmail1.SendOutlookMail(MType);
  if res then
    eResult.Text:='Generated.'
  else
    eResult.Text:='Error.'
end;

procedure TMain.btGenAutoClick(Sender: TObject);
begin
  SendMail(rmExternalAppPrefered);
end;

procedure TMain.btGenIntClick(Sender: TObject);
begin
  SendMail(rmInternal);
end;

procedure TMain.btGetExtClick(Sender: TObject);
begin
  SendMail(rmExternalAppOnly);
end;

procedure TMain.btAddBatchClick(Sender: TObject);
begin
  FillEmail;
  rMapiEmail1.SendAutomatically:=chSendAuto.Checked;
  rMapiEmail1.AddToBatchMail;
  eResult.Text:='Email added to batch queue.'
end;

procedure TMain.btSendBatchClick(Sender: TObject);
begin
  if not rMapiEmail1.ExternalAppExists then
  begin
    DlgI('Firstly open and compile project SendMail.dpr.');
    Exit;
  end;
  if rMapiEmail1.BatchMailList.Count = 0 then
    eResult.Text:='Batch list is empty. Add mail to batch.'
  else
    if rMapiEmail1.SendBatchMail(rmExternalAppOnly) then
      eResult.Text:='Batch started.'
    else
      eResult.Text:='Error.'
end;

end.
