unit f_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, rHTMLLabel, rImprovedComps, PropSaveMain, ComCtrls;

type
  TMain = class(TForm)
    gbDb: TrGroupBox;
    btReCon: TButton;
    cbLanguage: TrComboBoxEx;
    rHTMLLabel1: TrHTMLLabel;
    gbTabs: TrGroupBox;
    btFldCap: TButton;
    btProducts: TButton;
    btCat: TButton;
    btStockLevels: TButton;
    btSuppliers: TButton;
    PropSaveMain1: TPropSaveMain;
    tcInfo: TTabControl;
    mInfo: TrMemoEx;
    procedure btReConClick(Sender: TObject);
    procedure btProductsClick(Sender: TObject);
    procedure btStockLevelsClick(Sender: TObject);
    procedure btCatClick(Sender: TObject);
    procedure btFldCapClick(Sender: TObject);
    procedure cbLanguageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btSuppliersClick(Sender: TObject);
    procedure tcInfoChange(Sender: TObject);
  private
    { Private declarations }
    procedure TryRefresh;
  public
    { Public declarations }
  end;

var
  Main: TMain;

implementation

{$R *.dfm}
uses dm_data, dm_auxdata, f_products, rtool, f_stockleveledit, f_categoriesedit,
  f_cfgfieldlabels, f_suppliersedit;

procedure TMain.FormCreate(Sender: TObject);
begin
  gbTabs.SetAllChildren(chvSetEnability, false, nil, 1);
  tcInfoChange(nil);
end;

procedure TMain.btReConClick(Sender: TObject);
begin
  if not DMData.TryConnect then
    Exit;
  AuxData.ChangeLanguage(self.cbLanguage.Text);
  gbDb.SetAllChildren(chvSetEnability, true, nil, 1);
  gbTabs.SetAllChildren(chvSetEnability, true, nil, 1);
end;

procedure TMain.btProductsClick(Sender: TObject);
begin
  CreateF(TProducts, Products);
  Products.Show;
end;

procedure TMain.tcInfoChange(Sender: TObject);
var
  s: string;
begin
  mInfo.Lines.Clear;
  case tcInfo.TabIndex of
    0:
      s:='demo_info.txt';
    1:
      s:='comp_info.txt';
    else
      s:='';
    end;
  try
    mInfo.Lines.LoadFromFile(GetAppDir + s);
  except
  end;
end;

procedure TMain.TryRefresh;
begin
  if Assigned(Products) then
    Products.RefreshLists;
end;

procedure TMain.btStockLevelsClick(Sender: TObject);
begin
  if SelectStockLevel then
    TryRefresh;
end;

procedure TMain.btSuppliersClick(Sender: TObject);
begin
  if SelectSupplier then
    TryRefresh;
end;

procedure TMain.btCatClick(Sender: TObject);
begin
  if SelectCategory then
    TryRefresh;
end;

procedure TMain.btFldCapClick(Sender: TObject);
begin
  ShowFieldsLabel;
end;

procedure TMain.cbLanguageClick(Sender: TObject);
begin
  AuxData.ChangeLanguage(self.cbLanguage.Text);
end;

end.
